
CoCoALib - Design #1279

Tidy up code for matrix determinant

03 May 2019 11:47 - John Abbott

Status: Closed Start date: 03 May 2019

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: Tidying Estimated time: 2.66 hours

Target version: CoCoALib-0.99800 Spent time: 2.60 hours

Description

I recently encountered an unexpected error while trying to compute the determinant of a 2x2 matrix over ZZ/(841) where 841 = 29^2.

There seem to be several "suboptimal" aspects in the code:

DetDirect has an incorrect assertion that the ring is a PolyRing

DetDirect probably should not have been called anyway

why wasn't det2x2 called?

Review the code, and tidy it up!

Related issues:

Related to CoCoALib - Bug #1280: Determinant & Inverse of matrix over non int... In Progress 03 May 2019

History

#1 - 03 May 2019 13:58 - John Abbott

- Related to Bug #1280: Determinant & Inverse of matrix over non integral domain added

#2 - 09 Jan 2020 12:22 - John Abbott

- Target version changed from CoCoALib-0.99700 to CoCoALib-0.99800

#3 - 06 Oct 2020 15:20 - John Abbott

- Status changed from New to Resolved

- Assignee set to John Abbott

- % Done changed from 0 to 70

Main dispatch fn is ConstMatrixViewBase::myDet around  matrix.C:221

The code has already been considerably cleaned up, but still performs poorly for some inputs.

#4 - 29 Oct 2020 21:48 - John Abbott

- Description updated

- Status changed from Resolved to Closed

- % Done changed from 70 to 100

- Estimated time set to 2.66 h

The current version is acceptable; it could be made better, but there are plenty of other more important issues (at the moment).

Closing.
